'\" t
.\"     Title: libsmbclient
.\"    Author: [see the "AUTHOR" section]
.\" Generator: DocBook XSL Stylesheets v1.79.1 <http://docbook.sf.net/>
.\"      Date: 12/18/2019
.\"    Manual: 7
.\"    Source: Samba 4.10.11
.\"  Language: English
.\"
.TH "LIBSMBCLIENT" "7" "12/18/2019" "Samba 4\&.10\&.11" "7"
.\" -----------------------------------------------------------------
.\" * Define some portability stuff
.\" -----------------------------------------------------------------
.\" ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
.\" http://bugs.debian.org/507673
.\" http://lists.gnu.org/archive/html/groff/2009-02/msg00013.html
.\" ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
.ie \n(.g .ds Aq \(aq
.el       .ds Aq '
.\" -----------------------------------------------------------------
.\" * set default formatting
.\" -----------------------------------------------------------------
.\" disable hyphenation
.nh
.\" disable justification (adjust text to left margin only)
.ad l
.\" -----------------------------------------------------------------
.\" * MAIN CONTENT STARTS HERE *
.\" -----------------------------------------------------------------
.SH "NAME"
libsmbclient \- An extension library for browsers and that can be used as a generic browsing API\&.
.SH "SYNOPSIS"
.HP \w'\ 'u
.PP
Browser URL:
smb://[[[domain:]user[:password@]]server[/share[/path[/file]]]] [?options]
.SH "DESCRIPTION"
.PP
This tool is part of the
\fBsamba\fR(7)
suite\&.
.PP
libsmbclient
is a library toolset that permits applications to manipulate CIFS/SMB network resources using many of the standards POSIX functions available for manipulating local UNIX/Linux files\&. It permits much more than just browsing, files can be opened and read or written, permissions changed, file times modified, attributes and ACL\*(Aqs can be manipulated, and so on\&. Of course, its functionality includes all the capabilities commonly called browsing\&.
.PP
libsmbclient
can not be used directly from the command line, instead it provides an extension of the capabilities of tools such as file managers and browsers\&. This man page describes the configuration options for this tool so that the user may obtain greatest utility of use\&.
.SH "OPTIONS"
.PP
What the URLs mean:
.PP
smb://
.RS 4
Shows all workgroups or domains that are visible in the network\&. The behavior matches that of the Microsoft Windows Explorer\&.
.sp
The method of locating the list of workgroups (domains also) varies depending on the setting of the context variable
(context\->options\&.browse_max_lmb_count)\&. It is the responsibility of the application that calls this library to set this to a sensible value\&. This is a compile\-time option\&. This value determines the maximum number of local master browsers to query for the list of workgroups\&. In order to ensure that the list is complete for those present on the network, all master browsers must be queried\&. If there are a large number of workgroups on the network, the time spent querying will be significant\&. For small networks (just a few workgroups), it is suggested to set this value to 0, instructing libsmbclient to query all local master browsers\&. In an environment that has many workgroups a more reasonable setting may be around 3\&.
.RE
.PP
smb://name/
.RS 4
This command causes libsmbclient to perform a name look\-up\&. If the NAME<1D> or NAME<1B> exists (workgroup name), libsmbclient will list all servers in the workgroup (or domain)\&. Otherwise, a name look\-up for the NAME<20> (machine name) will be performed, and the list of shared resources on the server will be displayed\&.
.RE
.PP
When libsmbclient is invoked by an application it searches for a directory called
\&.smb
in the $HOME directory that is specified in the users shell environment\&. It then searches for a file called
smb\&.conf
which, if present, will fully over\-ride the system
/etc/samba/smb\&.conf
file\&. If instead libsmbclient finds a file called
~/\&.smb/smb\&.conf\&.append, it will read the system
/etc/samba/smb\&.conf
and then append the contents of the
~/\&.smb/smb\&.conf\&.append
to it\&.
.PP
libsmbclient
will check the users shell environment for the
USER
parameter and will use its value when if the
user
parameter was not included in the URL\&.
.SH "PROGRAMMERS GUIDE"
.PP
Watch this space for future updates\&.
.SH "VERSION"
.PP
This man page is part of version 4\&.10\&.11 of the Samba suite\&.
.SH "AUTHOR"
.PP
The original Samba software and related utilities were created by Andrew Tridgell\&. Samba is now developed by the Samba Team as an Open Source project similar to the way the Linux kernel is developed\&.
.PP
The libsmbclient manpage page was written by John H Terpstra\&.
